Bookmarks in JavaScript DOCX Editor

1 Sep 20266 minutes to read

Bookmark is a powerful tool that helps you to mark a place in the document to find again easily. You can enter many bookmarks in the document and give each one a unique name to identify easily.

JavaScript DOCX Editor (Document Editor) provides built-in dialog to add, delete, and navigate bookmarks within the document. To add a bookmark, select a portion of text in the document. After that, jump to the location or add links to it within the document using built-in hyperlink dialog. You can also delete bookmarks from a document.

Bookmark names need to begin with a letter. They can include both numbers and letters, but not spaces. To separate the words, use an underscore.
Bookmark names starting with an underscore are called hidden bookmarks. For example, bookmarks generated for table of contents.

Add bookmark

Using insertBookmark method, Bookmark can be added to the selected text.

this.container.documentEditor.editor.insertBookmark("Bookmark1");

Select and Navigate to a Bookmark

You can select a bookmark by its name using the selectBookmark method, which also navigates the editor to the bookmark location, as shown in the following code snippet.

this.container.documentEditor.selection.selectBookmark("Bookmark1", true);

Second parameter is optional parameter and it denotes is exclude bookmark start and end from selection. If true, excludes bookmark start and end from selection.

Delete Bookmark

You can delete a bookmark in the document using deleteBookmark method as shown in the following code snippet.

this.container.documentEditor.editor.deleteBookmark("Bookmark1");

Get Bookmark from document

You can get all the bookmarks in the document using the getBookmarks method on the DocumentEditor instance as shown in the following code snippet.

this.container.documentEditor.getBookmarks(false);

The boolean parameter denotes whether to include hidden bookmarks. If false, hidden bookmarks are ignored.

Get Bookmark from selection

You can get bookmarks in the current selection in the document using getBookmarks method on the Selection instance as shown in the following code snippet.

this.container.documentEditor.selection.getBookmarks(false);

Show or Hide bookmark

You can show or hide the bookmark indicators around bookmarked items in DOCX Editor component.

The following example code illustrates how to show or hide the bookmark indicators around bookmarked items.

this.container.documentEditor.documentEditorSettings.showBookmarks = true;

Replace bookmark content

Preserve the bookmark while replacing content

When you pass true for the excludeStartEnd parameter in selectBookmark, the bookmark start and end markers are preserved. The subsequent insertText call replaces only the content between the markers, so the bookmark remains intact and can be tracked later.

this.container.documentEditor.selection.selectBookmark("Bookmark1", true);
this.container.documentEditor.editor.insertText('Hello World');

Remove the bookmark while replacing content

When you omit the excludeStartEnd parameter (or pass false), the bookmark start and end markers are included in the selection. The subsequent insertText call replaces both the content and the markers, so the bookmark is removed and cannot be tracked later.

this.container.documentEditor.selection.selectBookmark("Bookmark1");
this.container.documentEditor.editor.insertText('Hello World');

Bookmark Dialog

The following example shows how to open bookmark dialog in DOCX Editor.

var documenteditor = new ej.documenteditor.DocumentEditor({ enableBookmarkDialog: true, enableSelection: true, enableEditor: true, isReadOnly: false, enableEditorHistory: true, height: '370px' });

documenteditor.appendTo('#DocumentEditor');

document.getElementById('dialog').addEventListener('click', function () {
    documenteditor.showDialog('Bookmark');
});
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-documenteditor/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-dropdowns/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/fabric.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/fabric.css" rel="stylesheet">    
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="toolbar">
            <button id="dialog">Dialog</button>  
        </div>
        <div style="width:100%;height: 100%">
            <!--Element which will render as DocumentEditor -->
            <div id="DocumentEditor"></div>
        </div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Online Demo

Explore how to insert and manage bookmarks in Word documents using the JavaScript (ES5) DOCX Editor in this live demo here.

See Also

Bookmarks in React DOCX Editor

1 Sep 20264 minutes to read

Bookmark is a powerful tool that helps you to mark a place in the document to find again easily. You can enter many bookmarks in the document and give each one a unique name to identify easily.

React DOCX Editor (Document Editor) provides built-in dialog to add, delete, and navigate bookmarks within the document. To add a bookmark, select a portion of text in the document. After that, jump to the location or add links to it within the document using built-in hyperlink dialog. You can also delete bookmarks from a document.

Bookmark names need to begin with a letter. They can include both numbers and letters, but not spaces. To separate the words, use an underscore.
Bookmark names starting with an underscore are called hidden bookmarks. For example, bookmarks generated for table of contents.

Add a Bookmark

Use the insertBookmark method to add a bookmark to the selected text.

The following code snippet assumes that container is a reference to the DocumentEditorContainerComponent instance declared in your React component.

this.container.documentEditor.editor.insertBookmark("Bookmark1");

Select and Navigate to a Bookmark

You can select a bookmark by its name using the selectBookmark method, which also navigates the editor to the bookmark location, as shown in the following code snippet.

this.container.documentEditor.selection.selectBookmark("Bookmark1", true);

The second parameter is optional and it denotes whether to exclude the bookmark start and end from the selection. If true, excludes bookmark start and end from selection.

Delete Bookmark

You can delete a bookmark in the document using deleteBookmark method as shown in the following code snippet.

this.container.documentEditor.editor.deleteBookmark("Bookmark1");

Get Bookmark from Document

You can get all the bookmarks in the document using the getBookmarks method on the DocumentEditor instance as shown in the following code snippet.

this.container.documentEditor.getBookmarks(false);

The boolean parameter denotes whether to include hidden bookmarks. If false, hidden bookmarks are ignored.

Get Bookmark from Selection

You can get bookmarks in the current selection in the document using the getBookmarks method on the Selection instance as shown in the following code snippet.

this.container.documentEditor.selection.getBookmarks(false);

Show or Hide Bookmark

You can show or hide the bookmark indicators around bookmarked items in DOCX Editor component.

The following example code illustrates how to show or hide the bookmark indicators around bookmarked items.

this.container.documentEditor.documentEditorSettings.showBookmarks = true;

Replace Bookmark Content

Preserve the Bookmark While Replacing Content

When you pass true for the excludeStartEnd parameter in selectBookmark, the bookmark start and end markers are preserved. The subsequent insertText call replaces only the content between the markers, so the bookmark remains intact and can be tracked later.

this.container.documentEditor.selection.selectBookmark("Bookmark1", true);
this.container.documentEditor.editor.insertText('Hello World');

Remove the Bookmark While Replacing Content

When you omit the excludeStartEnd parameter (or pass false), the bookmark start and end markers are included in the selection. The subsequent insertText call replaces both the content and the markers, so the bookmark is removed and cannot be tracked later.

this.container.documentEditor.selection.selectBookmark("Bookmark1");
this.container.documentEditor.editor.insertText('Hello World');

Bookmark Dialog

The following example shows how to open bookmark dialog in DOCX Editor.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import {
  DocumentEditorComponent,
  SfdtExport,
  Selection,
  Editor,
  BookmarkDialog,
} from '@syncfusion/ej2-react-documenteditor';
import { createRoot } from 'react-dom/client';

DocumentEditorComponent.Inject(SfdtExport, Selection, Editor, BookmarkDialog);
let documenteditor;
function App() {
  return (
    <div>
      <button onClick={showBookmarkDialog}>Dialog</button>
      <DocumentEditorComponent
        id="container"
        height={'330px'}
        ref={(scope) => {
          documenteditor = scope;
        }}
        isReadOnly={false}
        enableSelection={true}
        enableEditor={true}
        enableSfdtExport={true}
        enableBookmarkDialog={true}
      />
    </div>
  );
  function showBookmarkDialog() {
    //Open Bookmark dialog.
    documenteditor.documentEditor.showDialog('Bookmark');
  }
}
export default App;
const root = createRoot(document.getElementById('sample')!);
root.render(<App />);

Online Demo

Explore how to insert and manage bookmarks in Word documents using the React DOCX Editor in this live demo here.

See Also

Bookmarks in Vue DOCX Editor component

1 Sep 20266 minutes to read

Bookmark is a powerful tool that helps you to mark a place in the document to find again easily. You can enter many bookmarks in the document and give each one a unique name to identify easily.

Vue DOCX Editor (Document Editor) provides built-in dialog to add, delete, and navigate bookmarks within the document. To add a bookmark, select a portion of text in the document. After that, jump to the location or add links to it within the document using built-in hyperlink dialog. You can also delete bookmarks from a document.

Bookmark names need to begin with a letter. They can include both numbers and letters, but not spaces. To separate the words, use an underscore.
Bookmark names starting with an underscore are called hidden bookmarks. For example, bookmarks generated for table of contents.

Add bookmark

Using insertBookmark method, Bookmark can be added to the selected text.

this.$refs.container.ej2Instances.documentEditor.editor.insertBookmark("Bookmark1");

Select and Navigate to a Bookmark

You can select a bookmark by its name using the selectBookmark method, which also navigates the editor to the bookmark location, as shown in the following code snippet.

this.$refs.container.ej2Instances.documentEditor.selection.selectBookmark("Bookmark1", true);

Note: The second parameter is an optional parameter and it denotes whether to exclude the bookmark start and end from the selection. If true, excludes the bookmark start and end from the selection.

Delete Bookmark

You can delete bookmark in the document using deleteBookmark method as shown in the following code snippet.

this.$refs.container.ej2Instances.documentEditor.editor.deleteBookmark("Bookmark1");

Get Bookmark from document

You can get all the bookmarks in the document using getBookmarks method as shown in the following code snippet.

this.$refs.container.ej2Instances.documentEditor.getBookmarks(false);

Note: The parameter denotes whether to include hidden bookmarks. If false, hidden bookmarks are ignored.

Get Bookmark from selection

You can get bookmarks in current selection in the document using getBookmarks method as shown in the following code snippet.

this.$refs.container.ej2Instances.documentEditor.selection.getBookmarks(false);

Replace bookmark content

You can replace bookmark content without removing the bookmark start and end for backtracking the bookmark content.

this.$refs.container.ej2Instances.documentEditor.selection.selectBookmark("Bookmark1", true);
this.$refs.container.ej2Instances.documentEditor.editor.insertText('Hello World');

You can replace content by removing the bookmark start and end, thus the bookmark content can’t be tracked in future.

this.$refs.container.ej2Instances.documentEditor.selection.selectBookmark("Bookmark1");
this.$refs.container.ej2Instances.documentEditor.editor.insertText('Hello World');

Show or Hide bookmark

You can show or hide the square brackets around bookmarked items in DOCX Editor component.

The following example code illustrates how to show or hide square brackets around bookmarked items.

this.$refs.container.ej2Instances.documentEditorSettings.showBookmarks = true;

Bookmark Dialog

The following example shows how to open bookmark dialog in DOCX Editor.

<template>
    <div id="app">
        <div>
            <button v-on:click='showBookmarkDialog'>Open dialog</button>
        </div>
        <ejs-documenteditor ref="documenteditor" :enableSelection='true' :isReadOnly='false' :enableEditor='true'
            :enableEditorHistory='true' :enableBookmarkDialog='true' height="370px"
            style="width: 100%;"></ejs-documenteditor>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { DocumentEditorComponent as EjsDocumenteditor, Selection, Editor, SfdtExport, EditorHistory, BookmarkDialog } from '@syncfusion/ej2-vue-documenteditor';

const documenteditor = ref(null);
provide('DocumentEditor', [Selection, Editor, BookmarkDialog, EditorHistory, SfdtExport]);
const showBookmarkDialog = function () {
    //Open bookmark dialog.
    documenteditor.value.showDialog('Bookmark');
}

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-documenteditor/styles/material.css";
</style>
<template>
    <div id="app">
        <div>
            <button v-on:click='showBookmarkDialog'>Open dialog</button>
        </div>
        <ejs-documenteditor ref="documenteditor" :enableSelection='true' :isReadOnly='false' :enableEditor='true'
            :enableEditorHistory='true' :enableBookmarkDialog='true' height="370px"
            style="width: 100%;"></ejs-documenteditor>
    </div>
</template>
<script>
import { DocumentEditorComponent, Selection, Editor, SfdtExport, EditorHistory, BookmarkDialog } from '@syncfusion/ej2-vue-documenteditor';

export default {
    name: "App",
    components: {
        "ejs-documenteditor": DocumentEditorComponent
    },
    data: function () {
        return {
        };
    },
    provide: {
        //Inject require modules.
        DocumentEditor: [Selection, Editor, BookmarkDialog, EditorHistory, SfdtExport]
    },
    methods: {
        showBookmarkDialog: function () {
            //Open bookmark dialog.
            this.$refs.documenteditor.showDialog('Bookmark');
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-documenteditor/styles/material.css";
</style>

Online Demo

Explore how to insert and manage bookmarks in Word documents using the Vue DOCX Editor in this live demo here.

See Also

Bookmarks in Angular DOCX Editor

1 Sep 20264 minutes to read

Bookmark is a powerful tool that helps you to mark a place in the document to find again easily. You can enter many bookmarks in the document and give each one a unique name to identify easily.

Angular DOCX Editor (Document Editor) provides built-in dialog to add, delete, and navigate bookmarks within the document. To add a bookmark, select a portion of text in the document. After that, jump to the location or add links to it within the document using built-in hyperlink dialog. You can also delete bookmarks from a document.

Bookmark names need to begin with a letter. They can include both numbers and letters, but not spaces. To separate the words, use an underscore.
Bookmark names starting with an underscore are called hidden bookmarks. For example, bookmarks generated for table of contents.

Add bookmark

Use the insertBookmark method to add a bookmark to the selected text.

this.container.documentEditor.editor.insertBookmark("Bookmark1");

Select and Navigate to a Bookmark

You can select a bookmark by its name using the selectBookmark method, which also navigates the editor to the bookmark location, as shown in the following code snippet.

this.container.documentEditor.selection.selectBookmark("Bookmark1", true);

NOTE

The second parameter is optional and it denotes whether to exclude the bookmark start and end from the selection. If true, excludes bookmark start and end from selection.

Delete Bookmark

You can delete a bookmark in the document using deleteBookmark method as shown in the following code snippet.

this.container.documentEditor.editor.deleteBookmark("Bookmark1");

Get Bookmark from document

You can get all the bookmarks in the document using getBookmarks method as shown in the following code snippet.

this.container.documentEditor.getBookmarks(false);

NOTE

The boolean parameter denotes whether to include hidden bookmarks. If false, hidden bookmarks are ignored.

Get Bookmark from selection

You can get bookmarks in the current selection in the document using getBookmarks method as shown in the following code snippet.

this.container.documentEditor.selection.getBookmarks(false);

Replace bookmark content

You can replace bookmark content without removing the bookmark start and end for backtracking the bookmark content.

this.container.documentEditor.selection.selectBookmark("Bookmark1", true);
this.container.documentEditor.editor.insertText('Hello World');

You can replace content by removing the bookmark start and end, thus the bookmark content can’t be tracked in future.

this.container.documentEditor.selection.selectBookmark("Bookmark1");
this.container.documentEditor.editor.insertText('Hello World');

Show or Hide bookmark

You can show or hide the bookmark indicators around bookmarked items in DOCX Editor component.

The following example code illustrates how to show or hide the bookmark indicators around bookmarked items.

this.container.documentEditor.documentEditorSettings.showBookmarks = true;

Bookmark Dialog

The following example shows how to open bookmark dialog in DOCX Editor.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'
import { DocumentEditorAllModule } from '@syncfusion/ej2-angular-documenteditor'



import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import {
    DocumentEditorComponent, EditorService, SelectionService, SfdtExportService, EditorHistoryService, BookmarkDialogService
} from '@syncfusion/ej2-angular-documenteditor';

@Component({
imports: [
        
        ButtonModule,
        DocumentEditorAllModule
    ],


standalone: true,
      selector: 'app-container',
      // specifies the template string for the Document Editor component
      template: `<div><button ejs-button (click)="showBookmarkDialog()" >Dialog</button>
      <ejs-documenteditor #document_editor id="container" height="330px" style="display:block" [isReadOnly]=false [enableEditor]=true [enableEditorHistory]=true [enableBookmarkDialog]=true>
      </ejs-documenteditor></div>`,
      encapsulation: ViewEncapsulation.None,
      providers: [EditorService, SelectionService, SfdtExportService, EditorHistoryService, BookmarkDialogService]
})
export class AppComponent {
    @ViewChild('document_editor')
    public documentEditor?: DocumentEditorComponent;

    public showBookmarkDialog(): void {
          //Open the bookmark dialog.
          (this.documentEditor as DocumentEditorComponent).showDialog('Bookmark');
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Online Demo

Explore how to insert and manage bookmarks in Word documents using the Angular DOCX Editor in this live demo here.

See Also